#include <SPI.h>
#include <Wire.h>
#include <SD.h>
#include <SD_t3.h>

#include "Audio.h"
#include "arm_math.h"
int M1IN1 = 3;
int M1IN2 = 4;
int M2IN1 = 9;
int M2IN2 = 10;
const int anzahlZeitpunkte = 256;
const int anzahlFrequenz = 10;
int start = 0;
float maxi = 0;
int tMaxi = 0;
const int16_t laengeBufferAuto = anzahlZeitpunkte * 2; // länge des buffers für autocorrelation
float buffer[laengeBufferAuto] __attribute__ ((aligned (4)));
uint32_t output[laengeBufferAuto / 2] __attribute__ ((aligned (4)));// amplitude des ergebnisses
int zeitpunkt[laengeBufferAuto];
float bpm;
long interval = (60000 / bpm) * 4;    // Intervall, in dem ein Tanzschrittteil ausgeführt wird
float tanzGeschwindigkeit = bpm;      // Geschwindigkeit, mit der der Roboter tanzt
int vorherigeZeit = millis();         // Zeit bis Beginn des ersten Tanzschrittes
long ZeitFuerZufallszahl = 0; 
long randNumber;
//------------------------globaleVariablen---fft------------------------
const int myInput = AUDIO_INPUT_LINEIN;
//const int myInput = AUDIO_INPUT_MIC;

// Create the Audio components.  These should be created in the
// order data flows, inputs/sources -> processing -> outputs
AudioInputAnalog         adc1(A0);        // audio shield: mic or line-in
AudioAnalyzeFFT1024    myFFT;
AudioConnection patchCord1(adc1, 0, myFFT, 0);
int16_t intensFreqZeit[anzahlFrequenz][laengeBufferAuto];
//--------------------------------------------------------------
int aktZeitpunkt = 0;

void printBuffer() {
  for (int i = 0; i < laengeBufferAuto; i++) {
    Serial.print(i);
    Serial.print("\t");
    Serial.println(buffer[i]);
  }
}
void printBufferArrayspalte() { // wichtigste Ausgabefunktion
  for (int i = 0; i < laengeBufferAuto; i++) {
    Serial.print(i);
    Serial.print("\t");
    Serial.print(zeitpunkt[i]);
    Serial.print("\t");
    Serial.print(buffer[i]);
    Serial.print("\t");
    Serial.print(intensFreqZeit[2][i]);
    Serial.print ("\t");
    Serial.println();

  }
}
void printArray() {
  for (int j = 0; j < anzahlZeitpunkte; j += 2) {
    for (int i = 0; i < anzahlFrequenz; i++) {
      Serial.print("\t");
      Serial.print(intensFreqZeit[i][j]);
    }
    Serial.println();
  }
}

void collectFFT() { // sammelt Audiorohdaten
  int16_t n;
  aktZeitpunkt = 0;
  // immer dann true wenn genug Daten da für Frequenzanalyse und die fertig ist --> ca 86x pro sekunde
  while ( aktZeitpunkt < laengeBufferAuto) {
    if (myFFT.available()) { //initialisiert intensFreqZeit
      for (int j = 2; j < anzahlFrequenz; j++) {
        n = myFFT.output[j];
        //Serial.println(n);
        intensFreqZeit[j][aktZeitpunkt] = n;
        zeitpunkt[aktZeitpunkt] = millis();
        //Serial.print(intensFreqZeit[j][aktZeitpunkt]);
        //Serial.print("\t");
      }
      aktZeitpunkt += 2 ;
      //Serial.println();
    }
  }
}


void setup() {
  Serial.begin(9600);
  AudioMemory(12);
  initialisiereFFT();
  myFFT.windowFunction(AudioWindowHanning1024);
  pinMode(M1IN1, OUTPUT);
  pinMode(M1IN2, OUTPUT);

  pinMode(M2IN1, OUTPUT);
  pinMode(M2IN2, OUTPUT);
}
void fuelleBuffer(int freqband) { // überträgt Werte vom Rohdatenarray in der Spalte freqband ins Buffer
  for (int i = 0; i < laengeBufferAuto; i++) {
    buffer[i] = intensFreqZeit[freqband][i];
  }
}
void autokorrelation(int freqband) { // mathematische Operation für Vergleich mit sich selber
  fuelleBuffer(freqband);
  computeFft(0);
  buffer[0] = 0; // Durchschnitt des Signals wird auf Null gesetzt
  for (int i = 0; i < laengeBufferAuto; i += 2) {
    float a = buffer[i];
    float b = buffer[i + 1];
    float real = a * a + b * b; //Realteil
    float imag = 0;//Imaginärteil
    buffer[i] = real;
    buffer[i + 1] = imag;
  }
  computeIFft(0);

}
void findBeats() { // findet Maximum der Autokorrelationswerte
  int i = 0;
  maxi = 0;
  while ( buffer[i] > 0 && i < 512) {
    i += 2;
  }
  start = i;
  for (int i = start; i < laengeBufferAuto / 2; i++) {
    if (maxi < buffer[i]) {
      maxi = buffer[i];
      tMaxi = i;
    }
  }
  bpm = (zeitpunkt[tMaxi] - zeitpunkt[0]) * 60 / 1000; // berechnet bpm, hat manchmal verschiedene Werte die sich durch ganzzahlige Skalare unterscheiden
  Serial.print("Start: ");
  Serial.print(start);
  Serial.print("\t");
  Serial.print("tMaxi: ");
  Serial.print(tMaxi);
  Serial.print("\t");
  Serial.print("maxi: ");
  Serial.print(maxi);
  Serial.println("-------------------------------------------------------");

}
void bpmFestlegen() {
  if (bpm < 100) {
    bpm = bpm * 2;
  }
  if (bpm < 100) {
    bpm = bpm * 2;
  }
  if (bpm < 100) {
    bpm = bpm * 2;
  }
}

void loop() {
  collectFFT();
  autokorrelation(2);
  //printBufferArrayspalte();
  //printBuffer();
  findBeats();
  bpmFestlegen();
  Serial.println(bpm);
  randNumber = random(5);
  Serial.print("\t");
  Serial.print("randNumber: ");
  Serial.println(randNumber);

  if (randNumber == 0) {
    tanzschritt1();
  }
  if (randNumber == 1) {
    tanzschritt2();
  }
  if (randNumber == 2) {
    tanzschritt3();
  }
  if (randNumber == 3) {
    tanzschritt4();
  }
  if (randNumber == 4) {
    tanzschritt5();
  }
}



